private import std.string;
private import std.file;
private import std.c.stdio;
private import libbz2.bzlib;
private import win32.ansi.windows;
private import util;
private import std.zlib;
private import etc.c.zlib;
private import zlibwrap;

//----------------------------------------------------------------
// Bgaɂ̃t@Cwb_`
//----------------------------------------------------------------

align(1) struct BgaHeader
{
	 int   checksum;        // type`fname signed charł̘a
	char   method[4];       // "GZIP" ܂ "BZ2\0"
	uint   compressed_size; // k̃f[^TCY( wb_͊܂܂Ȃ )
	uint   original_size;   // ̃t@CTCY
	ushort date;            // t@C̍XVt( DOS` )
	ushort time;            // t@C̍XV( DOS` )
	ubyte  attrib;          // t@C̑
	                        // ( 1:RO 2:Hid 4:Sys 8:Vol 16:Dir 32:Arc )
	ubyte  header_type;     // wb_̎( ݂͏ 0 )
	ushort arc_type;        // A[JCu^Cv
	                        // 0:(ext==?񈳏k:k) 1:k 2:񈳏k
	                        //	.ARC, .ARJ, .BZ2, .BZA, .CAB, .GZ, .GZA, .LZH,
	                        //	.LZS, .PAK, .RAR, .TAZ, .TBZ, .TGZ, .Z, .ZIP, .ZOO
	ushort dir_name_len;    // fBNg̒
	ushort file_name_len;   // t@C̒
	char[] fname;           // dir_name_len + file_name_len ( no '\0' )
}

//----------------------------------------------------------------
// G[ɓO
//----------------------------------------------------------------

class BgaMelterError : Error
{
	int errcode;
	this( int e ) { super("BgaMelterError"); errcode=e; }
}

enum
{
	ERROR_FILE_OPEN=0x800D,//         t@CJ܂łB
	ERROR_MAKEDIRECTORY=0x8012,//     fBNg쐬ł܂B
	ERROR_CANNOT_WRITE=0x8013,//      ݃G[܂B
	ERROR_HEADER_CRC=0x8016,//        ɂ̃wb_̃`FbNTĂ܂B
	ERROR_ARC_FILE_OPEN=0x8018,//     ɂJo܂B
	ERROR_NOT_ARC_FILE=0x8019,//      ɂ̃t@Cw肳Ă܂B
	ERROR_CANNOT_READ=0x801A,//       t@C̓ǂݍݎɃG[܂B
	ERROR_FILE_STYLE=0x801B,//        w肳ꂽt@C͗Lȏɂł͂܂B
	ERROR_COMMAND_NAME=0x801C,//      R}hw肪ԈĂ܂B
	ERROR_MORE_HEAP_MEMORY=0x801D,//  Ɨp̂߂̃q[vsĂ܂B
	ERROR_ALREADY_RUNNING=0x801F,//    BGA32.DLL 쒆łB
	ERROR_USER_CANCEL=0x8020,//       [U[ɂď𒆒f܂B
	ERROR_TMP_OPEN=0x8025,//          ƃt@C쐬ł܂B
	ERROR_ARC_READ_ONLY=0x8027,//     ݐp̏ɂɑ΂鑀͂ł܂B
	ERROR_NOT_FIND_ARC_FILE=0x8029,// w肳ꂽfBNgɂ͏ɂ܂łB
	ERROR_RESPONSE_READ=0x802A,//     X|Xt@C̓ǂݍݎɃG[܂B
	ERROR_TMP_COPY=0x802C,//          ƃt@C̏ɂւ̏߂ł܂łB
	ERROR_NOT_FIND_FILE=0x8031,//     t@C܂B
	ERROR_GET_ATTRIBUTES=0x8034,//    t@C擾ł܂B
	ERROR_GET_INFORMATION=0x8036,//   t@C񂪎擾ł܂B
}

//----------------------------------------------------------------
// R[obN֐̕ԓp^
//----------------------------------------------------------------

enum BgaAnswer
{
	MeltIt, SkipIt, Abort
}

//----------------------------------------------------------------
// Filep
//   D炵ʂ̂łzliblibbz2ƊȒPɘAg
//   sstd.c.stdio.FILE*Ńt@Cǂݏ܂B
//----------------------------------------------------------------

extern(C)
{
	// stdio.h
    int fileno( FILE *fp ) { return fp._file; }
	// io.h
	int lseek( int fd, int offset, int mode );
	int dup( int fd ); 
	int close( int fd );
}

class Filep
{
	private FILE* fp;
	private this( FILE* p ) { fp = p; }

	static Filep open( char[] filename, bool read )
	{
		FILE* fp = fopen( toStringz(filename), read?"rb":"wb" );
		return (fp ? new Filep(fp) : null);
	}

	int dup_han()
	{
		int fd = dup( fileno(fp) );
		lseek( fd, cur(), 0 );
		return fd;
	}

	void[] read( int siz )
	{
		char[] buf; buf.length = siz;
		int rsiz = fread( buf, 1, siz, fp );
		if( rsiz < 0 )
			throw new BgaMelterError(ERROR_FILE_OPEN);
		buf.length = rsiz;
		return buf;
	}

	void write( void[] buf )
	{
		while( buf.length > 0 )
		{
			int rsiz = fwrite( buf, 1, buf.length, fp );
			if( rsiz < 0 ) return;
			buf = buf[rsiz .. length];
		}
	}

	int cur()
	{
		return ftell(fp);
	}

	void seek_to( int i )
	{
		fseek( fp, i, std.c.stdio.SEEK_SET );
	}

	void close()
	{
		fclose(fp);
	}

	FILE* get_fp()
	{
		return fp;
	}
}


//----------------------------------------------------------------
// CNX
//----------------------------------------------------------------

class BgaMelter
{
	alias BgaAnswer delegate(inout BgaHeader) FileHandler;
	alias BgaAnswer delegate(int, int)        ProgressHandler;

	private Filep fp = null;

	this( char[] arc_name )
	{
		fp = Filep.open( arc_name, true );
		if( fp is null )
			throw new BgaMelterError(ERROR_FILE_OPEN);
	}

	void close()
	{
		if( fp ) { fp.close(); fp = null; }
	}

	void start( FileHandler fh, ProgressHandler ph )
	{
		try
		{
			// wb_T
			int hpos = find_header();
			if( hpos == -1 )
				throw new BgaMelterError(ERROR_NOT_ARC_FILE);
			fp.seek_to(hpos);

			// [vF
			// wb_ǂ݂Ƃ
			BgaHeader hdr;
			while( read_header(hdr) )
			{
				// ̃wb_ʒuvZĂ
				uint nextpos = fp.cur() + hdr.compressed_size;
				try
				{
					// callback
					BgaAnswer a = fh(hdr);
					if( a == BgaAnswer.Abort )  return;
					if( a == BgaAnswer.SkipIt ) continue;

					// o͐t@CJ
					if( lastChar(hdr.fname)=='\\' )
					  { pathMake(hdr.fname); continue; }

					Filep outf = Filep.open( pathMake(hdr.fname), false );
					if( outf is null )
						throw new BgaMelterError(ERROR_FILE_OPEN);

					// 𓀏
					if( !is_compressed(hdr) )
						NcDec( hdr.original_size, outf );
					else if( hdr.method == "GZIP" )
						GzDec( hdr.compressed_size, hdr.original_size, outf );
					else if( hdr.method == "BZ2\0" )
						BzDec( hdr.original_size, outf );

					// đݒ
					outf.close();
					dosSetFTime( hdr.fname, hdr.date, hdr.time );
					SetFileAttributes( hdr.fname, hdr.attrib );
				}
				finally { fp.seek_to(nextpos); }
			}
		}
		finally { close(); }
	}

	static int signed_char( char c )
	{
		int cn = c;
		return (cn>=0x80 ? cn|0xffffff00 : cn);
	}

	private int find_header()
	{
		char[] dat = cast(char[]) fp.read(0x10000);

		for( int i=0; i<dat.length-28; ++i )
		{
			if( dat[i+4]!='G' && dat[i+4]!='B' ) continue;
			if( dat[i+5]!='Z'                  ) continue;
			if( dat[i+6]!='I' && dat[i+6]!='2' ) continue;
			if( dat[i+7]!='P' && dat[i+7]!='\0') continue;

			 int checksum = dat[i+0]+(dat[i+1]<<8)+(dat[i+2]<<16)+(dat[i+3]<<24);
			uint fnlen    = dat[i+24]+(dat[i+25]<<8)+dat[i+26]+(dat[i+27]<<8);
			if( i+28+fnlen > dat.length )        continue;

			int sum = 0;
			for( int j=i+4; j!=i+28+fnlen; ++j )
				sum += signed_char(dat[j]);
			if( checksum == sum )
				return i;
		}

		return -1;
	}

	private bool read_header( out BgaHeader hdr )
	{
		// gGfBABwb_ǂݍ
		char[] buf = cast(char[]) fp.read(28);
		if( buf.length < 28 ) return false;
		buf.length = BgaHeader.sizeof;
		hdr = (cast(BgaHeader[]) buf)[0];
		hdr.fname = "";

		// t@C
		hdr.fname = cast(char[]) fp.read(hdr.dir_name_len + hdr.file_name_len);
		if( hdr.fname.length < hdr.dir_name_len + hdr.file_name_len ) return false;

		// `FbNT
		int sum = 0;
		for( int i=4; i!=28; ++i )    sum += signed_char(buf[i]);
		foreach( char c ; hdr.fname ) sum += signed_char(c);
		return (sum == hdr.checksum);
	}

	private bool is_compressed( inout BgaHeader hdr ) // inout=just for optimization
	{
		// wb_At@Cki[Ă邩ǂ𔻒
		if( hdr.arc_type==2 )
			return false;
		if( hdr.arc_type==0 && hdr.compressed_size==hdr.original_size )
		{
			int x = rfind( hdr.fname, '.' );
			if( x == -1 )
				return true;
			char[] ext = tolower(hdr.fname[x+1 .. length]);
			if( ext=="arc" || ext=="arj" || ext=="bz2" || ext=="bza"
			 || ext=="cab" || ext=="gz"  || ext=="gza" || ext=="lzh"
			 || ext=="lzs" || ext=="pak" || ext=="rar" || ext=="taz"
			 || ext=="tbz" || ext=="tgz" || ext=="z"   || ext=="zip"
			 || ext=="zoo" )
				return false;
		}
		return true;
	}

	static char[] pathMake( char[] path )
	{
		char* ps = toStringz(path);
		for(char* p=ps;;)
		{
			for(; *p!=0&&*p!='\\'&&*p!='/'; p=CharNext(p)) {}
			if( *p==0 )
				break;
			CreateDirectory( toStringz(ps[0..(p-ps)]), null );
			++p;
		}
		return path;
	}

	enum { BUFSIZ = 65536 }

	private void NcDec( uint usiz, Filep outf )
	{
		// 񈳏kBRs[邾
		while( usiz )
		{
			char[] r = cast(char[]) fp.read( BUFSIZ<usiz?BUFSIZ:usiz );
			usiz -= r.length;
			outf.write(r);
		}
	}

	private void GzDec( uint csiz, uint usiz, Filep outf )
	{
		// zlibœWJ
		fp.read(10); csiz -= 20; // wb_,tb^XLbv
		zlibwrap.inflate( fp, csiz, outf, usiz );
	}

	private void BzDec( uint usiz, Filep outf )
	{
		// libbz2œWJ
		int err;
		BZFILE* b = BZ2_bzReadOpen( &err, fp.get_fp(), 0, 0, NULL, 0 );
		if( err!=BZ_OK || b is null )
			return;

		try
		{
			char[] buf; buf.length = BUFSIZ;
			int len;
			while( 0<(len=BZ2_bzRead( &err, b, buf, BUFSIZ<usiz?BUFSIZ:usiz )) )
			{
				outf.write( buf[0..len] );
				usiz -= len;
				if( err != BZ_OK )
					break;
			}
		} finally { BZ2_bzReadClose( &err, b ); }
	}
}
